#coding=utf-8
#產生lonote的各種程式路徑
#發覺在lonote的程式碼中，有一堆要解算路徑的地方，受不了了！能夠獨立出來的全部都獨立放在這裡吧！

import os, sys, shutil, filecmp

class fix:
    '''程式啟動之後就不會變動的路徑'''
    def cfgDir():
        '''取得可存取的設定檔資料夾路徑'''
        if os.access(progDir, os.W_OK):
            lonoteConfigPath = progDir
        else:
            configPath = os.path.join(os.getenv('HOME'), '.config')
            lonoteConfigPath = os.path.join(configPath, 'lonote')
            if not os.path.isdir(configPath):
                os.mkdir(configPath)
            if not os.path.isdir(lonoteConfigPath):
                os.mkdir(lonoteConfigPath)
        return lonoteConfigPath

    def iconDir():
        '''取得icon資料夾路徑'''
        iconsDir = os.path.join(progDir, 'icons')
        #如果路徑是?/bin/，退出bin進入?/share/lonote/icons
        if not os.path.isdir(iconsDir):
            iconsDir = os.path.join(os.path.dirname(progDir),
                    'share',
                    'lonote',
                    'icons')
        return iconsDir

    def defaultTemplateDir():
        '''取得系統的template資料夾路徑'''
        defaultTemplateDir = os.path.join(progDir, 'default', 'template')
        #如果路徑是?/bin/，退出bin進入?/share/lonote/default/template
        if not os.path.isdir(defaultTemplateDir):
            defaultTemplateDir = os.path.join(os.path.dirname(progDir),
                    'share',
                    'lonote',
                    'default',
                    'template')
        return defaultTemplateDir

    def templateDir():
        '''取得實際template資料夾路徑，如果路徑無效的話，用defaut寫入'''
        templateDir = os.path.join(cfgDir, 'template')
        if not os.path.isdir(templateDir):
            shutil.copytree(fix.defaultTemplateDir(), templateDir)
        return templateDir

    def defaultCSSDir():
        '''取得系統預設的CSS目錄路徑'''
        defaultCSSDir = os.path.join(progDir, 'default', 'css')
        #如果路徑是?/bin/，退出bin進入?/share/lonote/default
        if not os.path.isdir(defaultCSSDir):
            defaultCSSDir = os.path.join(os.path.dirname(progDir),
                    'share',
                    'lonote',
                    'default',
                    'css')
        return defaultCSSDir

    def cssDir():
        '''取得實際要用的CSS目錄路徑'''
        cssDir = os.path.join(cfgDir, 'css')
        #如果不存在拷貝全部
        if not os.path.isdir(cssDir):
            shutil.copytree(fix.defaultCSSDir(), cssDir)
        else: #如果存在，選擇default有的但cssDir沒有的拷貝過去
            defCSSDir = fix.defaultCSSDir()
            for name in filecmp.dircmp(defCSSDir, cssDir).left_only:
                path = os.path.join(defCSSDir, name)
                if os.path.isfile(path):
                    shutil.copy(path, os.path.join(cssDir, name))
        return cssDir

    def defaultNav():
        '''取得系統預設的Nav模板檔案路徑'''
        defaultNav = os.path.join(progDir, 'default', 'nav.html')
        #如果路徑是?/bin/，退出bin進入?/share/lonote/default
        if not os.path.isfile(defaultNav):
            defaultNav = os.path.join(os.path.dirname(progDir),
                    'share',
                    'lonote',
                    'default',
                    'nav.html')
        return defaultNav

    def lonoteNav():
        '''取得實際要用的Nav模板檔案路徑'''
        lonoteNav = os.path.join(cfgDir, 'nav.html')
        if not os.path.isfile(lonoteNav):
            shutil.copy(fix.defaultNav(), lonoteNav)
        return lonoteNav

    def localeDir():
        '''取得locale的目錄'''
        localeDir = os.path.join(progDir, 'locale')
        #如果路徑是?/bin/，退出bin進入?/share/locale
        if not os.path.isdir(localeDir):
            localeDir = os.path.join(os.path.dirname(progDir),
                    'share',
                    'locale')
        return localeDir

    def exampleDir():
        '''取得範例的總目錄'''
        exampleDir = os.path.join(progDir, 'example')
        #如果路徑是?/bin/，退出bin進入?/share/lonote/example
        if not os.path.isdir(exampleDir):
            exampleDir = os.path.join(os.path.dirname(progDir),
                    'share',
                    'lonote',
                    'example')
        return exampleDir

#程式路徑集中定義在這裡

#程式路徑
progDir = os.path.abspath(os.path.dirname(sys.argv[0]))

#config資料夾路徑
cfgDir = fix.cfgDir()

language = os.path.join(cfgDir, 'language')
cfg = os.path.join(cfgDir, 'lonoterc')
templateDir = fix.templateDir()
cssDir = fix.cssDir()
lonoteNav = fix.defaultNav() #暫時不給使用者自訂Nav模板檔－－覺得預設Nav還寫得不夠好。暫時保留……

#locale資料夾
localeDir = fix.localeDir()

#圖示資料夾
iconDir = fix.iconDir()

class icons:
    intemplate = os.path.join(iconDir, 'intemplate.png')
    bold = os.path.join(iconDir, 'bold.png')
    italic = os.path.join(iconDir, 'italic.png')
    underline = os.path.join(iconDir, 'underline.png')
    strike = os.path.join(iconDir, 'strike.png')
    sup = os.path.join(iconDir, 'sup.png')
    sub = os.path.join(iconDir, 'sub.png')
    left = os.path.join(iconDir, 'left.png')
    center = os.path.join(iconDir, 'center.png')
    right = os.path.join(iconDir, 'right.png')
    indent = os.path.join(iconDir, 'indent.png')
    outdent = os.path.join(iconDir, 'outdent.png')
    ordlist = os.path.join(iconDir, 'ordlist.png')
    bullist = os.path.join(iconDir, 'bullist.png')
    forecol = os.path.join(iconDir, 'forecol.png')
    bgcol = os.path.join(iconDir, 'bgcol.png')
    inimg = os.path.join(iconDir, 'inimg.png')
    link = os.path.join(iconDir, 'link.png')
    unlink = os.path.join(iconDir, 'unlink.png')
    noformat = os.path.join(iconDir, 'noformat.png')
    inatt = os.path.join(iconDir, 'inatt.png')
    inhtml = os.path.join(iconDir, 'inhtml.png')
    indate = os.path.join(iconDir, 'indate.png')
    intime = os.path.join(iconDir, 'intime.png')
    close = os.path.join(iconDir, 'close.png')
    yes = os.path.join(iconDir, 'yes.png')
    before = os.path.join(iconDir, 'before.png')
    newnote = os.path.join(iconDir, 'newnote.png')
    newsubnote = os.path.join(iconDir, 'newsubnote.png')
    delnote = os.path.join(iconDir, 'delnote.png')
    newnotebook = os.path.join(iconDir, 'newnotebook.png')
    loadnotebook = os.path.join(iconDir, 'loadnotebook.png')
    notebook = os.path.join(iconDir, 'notebook.png')
    lonote = os.path.join(iconDir, 'lonote.png')
    about = os.path.join(iconDir, 'about.png')
    aboutbutton = os.path.join(iconDir, 'aboutbutton.png')
    questiondialog = os.path.join(iconDir, 'questiondialog.png')
    error = os.path.join(iconDir, 'error.png')
    cfgdialog = os.path.join(iconDir, 'cfg.png')
    khappy = os.path.join(iconDir, 'khappy.png')
    kworking = os.path.join(iconDir, 'kworking.png')
    export = os.path.join(iconDir, 'intemplate.png')
    fairy = os.path.join(iconDir, 'fairy.png')


#範例資料夾
exampleDir = fix.exampleDir()

class cal:
    '''程式啟動後會隨時變動，需要給值計算後才能獲知的路徑'''
    def bookdb(bookdir):
        '''透過bookdir取得booknote.db的位置'''
        return os.path.join(bookdir, 'notebook.db')
    def exportdir(bookdir):
        '''透過bookdir取得匯出路徑'''
        return os.path.join(bookdir, 'export')
    def booklock(bookdir):
        '''透過bookdir取得booknote.db的位置'''
        return os.path.join(bookdir, 'FILELOCK.lock')
    def bhistory(bookdir):
        '''透過bookdir取得booknote的位置'''
        return os.path.join(bookdir, 'browsinghistory')
    def exportnav(bookdir):
        '''透過bookdir取得book的nav模版'''
        #筆記本nav放在筆記本路徑下
        b = os.path.join(bookdir, 'nav.html')
        if os.path.isfile(b): return b
        return lonoteNav
#    def exportframe(bookdir):
#        '''透過bookdir取得book的frame模版'''
#        #筆記本frame放在筆記本路徑下
#        b = os.path.join(bookdir, 'frame.html')
#        if os.path.isfile(b): return b
#        return lonoteFrame
    def notedir(bookdir, id):
        '''透過bookdir與id取得單一筆記的個體路徑'''
        return os.path.join(bookdir, 'data', str(id))
    def noteemb(bookdir, id):
        '''透過bookdir與id取得圖檔的路徑'''
        return os.path.join(bookdir, 'data', str(id), 'embedded')
    def noteatt(bookdir, id):
        '''透過bookdir與id取得附件的路徑'''
        return os.path.join(bookdir, 'data', str(id), 'attached')
    def notecss(bookdir, id, defaultCSS = 'lonote.css'):
        '''透過bookdir與id取得css的路徑，回傳css檔案'''
        #頁面專用css放在notedir中
        n = os.path.join(cal.notedir(bookdir, id), 'note.css')
        if os.path.isfile(n): return n
        #筆記本css放在筆記本路徑下
        b = os.path.join(bookdir, 'notebook.css')
        if os.path.isfile(b): return b
        #全域css放在cssDir底下
        return os.path.join(cssDir, defaultCSS)
